using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using SolarWinds.Orion.Web;
using System.Collections.Generic;
using SolarWinds.NPM.Web.Gauge.V1;

public partial class CustomOIDEditGauge : SolarWinds.Orion.NPM.Web.UI.CustomOIDGaugeEditPage
{	
	protected override void OnInit(EventArgs e)
	{
		base.OnInit(e);
		
		if (!string.IsNullOrEmpty(Request.QueryString["CustomPollerNetObject"]))
			_CustomPollernetObjectID = Request.QueryString["CustomPollerNetObject"];

        resourceTitleEditor.ResourceTitle = Resource.Title;
        resourceTitleEditor.ResourceSubTitle = Resource.SubTitle;

        if (!IsPostBack)
        {
            //Set scale input
            string scale_1 = Resource.Properties["Scale_1"];
			string scale_2 = Resource.Properties["Scale_2"];
			string scale_3 = Resource.Properties["Scale_3"];
            if (string.IsNullOrEmpty(scale_1))
                scale_1 = "100";
            if (string.IsNullOrEmpty(scale_2))
                scale_2 = "100";
            if (string.IsNullOrEmpty(scale_3))
                scale_3 = "100";				
            scaleInput_1.Text = scale_1;
			scaleInput_2.Text = scale_2;
			scaleInput_3.Text = scale_3;

            //Set custom poller properties
            using (SolarWinds.NPM.Common.NPMBusinessLayerProxy proxy = SolarWinds.NPM.Common.NPMBusinessLayerProxy.CreateNPMBusinessLayerProxy(ControlBusinessLayerExceptionHandler))
            {
                CustomPoller_1.DataSource = proxy.GetCurrentCustomPollersAssigned(CustomPollerNodeID, CustomPollerInterfaceID);
				CustomPoller_2.DataSource = proxy.GetCurrentCustomPollersAssigned(CustomPollerNodeID, CustomPollerInterfaceID);
				CustomPoller_3.DataSource = proxy.GetCurrentCustomPollersAssigned(CustomPollerNodeID, CustomPollerInterfaceID);

            }
            CustomPoller_1.DataTextField = "UniqueName";
            CustomPoller_1.DataValueField = "CustomPollerID";
            CustomPoller_1.DataBind();

            CustomPoller_2.DataTextField = "UniqueName";
            CustomPoller_2.DataValueField = "CustomPollerID";
            CustomPoller_2.DataBind();
			
            CustomPoller_3.DataTextField = "UniqueName";
            CustomPoller_3.DataValueField = "CustomPollerID";
            CustomPoller_3.DataBind();

			
            if (!string.IsNullOrEmpty(Resource.Properties["CustomPollerID_1"]))
                if (CustomPoller_1.Items.FindByValue(Resource.Properties["CustomPollerID_1"]) != null)
                    CustomPoller_1.SelectedValue = Resource.Properties["CustomPollerID_1"];

            if (!string.IsNullOrEmpty(Resource.Properties["CustomPollerID_2"]))
                if (CustomPoller_2.Items.FindByValue(Resource.Properties["CustomPollerID_2"]) != null)
                    CustomPoller_2.SelectedValue = Resource.Properties["CustomPollerID_2"];					
					
            if (!string.IsNullOrEmpty(Resource.Properties["CustomPollerID_3"]))
                if (CustomPoller_3.Items.FindByValue(Resource.Properties["CustomPollerID_3"]) != null)
                    CustomPoller_3.SelectedValue = Resource.Properties["CustomPollerID_3"];						
					
					
					
            if (!string.IsNullOrEmpty(Resource.Properties["Min_1"]))
                GaugeMinVal_1.Text = Resource.Properties["Min_1"];
            else
                GaugeMinVal_1.Text = "0";

            if (!string.IsNullOrEmpty(Resource.Properties["Min_2"]))
                GaugeMinVal_2.Text = Resource.Properties["Min_2"];
            else
                GaugeMinVal_2.Text = "0";	

            if (!string.IsNullOrEmpty(Resource.Properties["Min_3"]))
                GaugeMinVal_3.Text = Resource.Properties["Min_3"];
            else
                GaugeMinVal_3.Text = "0";	
				
            if (!string.IsNullOrEmpty(Resource.Properties["Max_1"]))
                GaugeMaxVal_1.Text = Resource.Properties["Max_1"];
            else
                GaugeMaxVal_1.Text = "100";

            if (!string.IsNullOrEmpty(Resource.Properties["Max_2"]))
                GaugeMaxVal_2.Text = Resource.Properties["Max_2"];
            else
                GaugeMaxVal_2.Text = "100";	
				
            if (!string.IsNullOrEmpty(Resource.Properties["Max_3"]))
                GaugeMaxVal_3.Text = Resource.Properties["Max_3"];
            else
                GaugeMaxVal_3.Text = "100";	
				
				
            if (!string.IsNullOrEmpty(Resource.Properties["OldEngine_1"]))
                OldEngine_1.SelectedValue = Resource.Properties["OldEngine_1"];
            else
                OldEngine_1.SelectedValue = "0";	
				
            if (!string.IsNullOrEmpty(Resource.Properties["OldEngine_2"]))
                OldEngine_2.SelectedValue = Resource.Properties["OldEngine_2"];
            else
                OldEngine_2.SelectedValue = "0";
				
            if (!string.IsNullOrEmpty(Resource.Properties["OldEngine_3"]))
                OldEngine_3.SelectedValue = Resource.Properties["OldEngine_3"];
            else
                OldEngine_3.SelectedValue = "0";		
				
				

            if (!string.IsNullOrEmpty(Resource.Properties["CustomScales_1"]))
                AutoScaleGauge_1.SelectedValue = Resource.Properties["CustomScales_1"];
            else
                AutoScaleGauge_1.SelectedValue = "1";

            if (!string.IsNullOrEmpty(Resource.Properties["CustomScales_2"]))
                AutoScaleGauge_2.SelectedValue = Resource.Properties["CustomScales_2"];
            else
                AutoScaleGauge_2.SelectedValue = "1";				


            if (!string.IsNullOrEmpty(Resource.Properties["CustomScales_3"]))
                AutoScaleGauge_3.SelectedValue = Resource.Properties["CustomScales_3"];
            else
                AutoScaleGauge_3.SelectedValue = "1";	
				
            if (!string.IsNullOrEmpty(Resource.Properties["AutoHide"]))
                AutoHide.SelectedValue = Resource.Properties["AutoHide"];
            else 
				AutoScaleGauge_1.SelectedValue = "0" ;
				
            if (!string.IsNullOrEmpty(Resource.Properties["AutoHide"]))
                AutoHide.SelectedValue = Resource.Properties["AutoHide"];
            else 
				AutoScaleGauge_2.SelectedValue = "0" ;
				
				
            if (!string.IsNullOrEmpty(Resource.Properties["AutoHide"]))
                AutoHide.SelectedValue = Resource.Properties["AutoHide"];
            else 
				AutoScaleGauge_3.SelectedValue = "0" ;

            if (!string.IsNullOrEmpty(Resource.Properties["Legends_1"]))
                if (GaugeTickCount_1.Items.FindByValue(Resource.Properties["Legends_1"]) != null)
                    GaugeTickCount_1.SelectedValue = Resource.Properties["Legends_1"];

            if (!string.IsNullOrEmpty(Resource.Properties["Legends_2"]))
                if (GaugeTickCount_2.Items.FindByValue(Resource.Properties["Legends_2"]) != null)
                    GaugeTickCount_2.SelectedValue = Resource.Properties["Legends_2"];					
					
            if (!string.IsNullOrEmpty(Resource.Properties["Legends_3"]))
                if (GaugeTickCount_3.Items.FindByValue(Resource.Properties["Legends_3"]) != null)
                    GaugeTickCount_3.SelectedValue = Resource.Properties["Legends_3"];	

					
            if (!string.IsNullOrEmpty(Resource.Properties["CustomLegends_1"]))
                CustomLegend_1.Text = Resource.Properties["CustomLegends_1"];
            else
                CustomLegend_1.Text = string.Empty;

            if (!string.IsNullOrEmpty(Resource.Properties["CustomLegends_2"]))
                CustomLegend_2.Text = Resource.Properties["CustomLegends_2"];
            else
                CustomLegend_2.Text = string.Empty;		
				
            if (!string.IsNullOrEmpty(Resource.Properties["CustomLegends_3"]))
                CustomLegend_3.Text = Resource.Properties["CustomLegends_3"];
            else
                CustomLegend_3.Text = string.Empty;	
				
            if (!string.IsNullOrEmpty(Resource.Properties["Title_1"]))
                Title_1.Text = Resource.Properties["Title_1"];
            else
                Title_1.Text = Resource.Properties["CustomPollerName_1"];

            if (!string.IsNullOrEmpty(Resource.Properties["Title_2"]))
                Title_2.Text = Resource.Properties["Title_2"];
            else
                Title_2.Text = Resource.Properties["CustomPollerName_2"];
				
            if (!string.IsNullOrEmpty(Resource.Properties["Title_3"]))
                Title_3.Text = Resource.Properties["Title_3"];
            else
                Title_3.Text = Resource.Properties["CustomPollerName_3"];
				
				
            if (!string.IsNullOrEmpty(Resource.Properties["WarningLevel_1"]))
                WarningLevel_1.Text = Resource.Properties["WarningLevel_1"];
            else
                WarningLevel_1.Text = string.Empty;

            if (!string.IsNullOrEmpty(Resource.Properties["WarningLevel_2"]))
                WarningLevel_2.Text = Resource.Properties["WarningLevel_2"];
            else
                WarningLevel_2.Text = string.Empty;
				
            if (!string.IsNullOrEmpty(Resource.Properties["WarningLevel_3"]))
                WarningLevel_3.Text = Resource.Properties["WarningLevel_3"];
            else
                WarningLevel_3.Text = string.Empty;		
				
				
            if (!string.IsNullOrEmpty(Resource.Properties["ErrorLevel_1"]))
                ErrorLevel_1.Text = Resource.Properties["ErrorLevel_1"];
            else
                ErrorLevel_1.Text = string.Empty;
	
            if (!string.IsNullOrEmpty(Resource.Properties["ErrorLevel_2"]))
                ErrorLevel_2.Text = Resource.Properties["ErrorLevel_2"];
            else
                ErrorLevel_2.Text = string.Empty;	
				
				
            if (!string.IsNullOrEmpty(Resource.Properties["ErrorLevel_3"]))
                ErrorLevel_3.Text = Resource.Properties["ErrorLevel_3"];
            else
                ErrorLevel_3.Text = string.Empty;
				

            if (!string.IsNullOrEmpty(Resource.Properties["ReverseThreshold_1"]))
                ReverseThreshold_1.SelectedValue = Resource.Properties["ReverseThreshold_1"];
            else
                ReverseThreshold_1.SelectedValue = "0";
				
				
				
            if (!string.IsNullOrEmpty(Resource.Properties["ReverseThreshold_2"]))
                ReverseThreshold_2.SelectedValue = Resource.Properties["ReverseThreshold_2"];
            else
                ReverseThreshold_2.SelectedValue = "0";	

				
            if (!string.IsNullOrEmpty(Resource.Properties["ReverseThreshold_3"]))
                ReverseThreshold_3.SelectedValue = Resource.Properties["ReverseThreshold_3"];
            else
                ReverseThreshold_3.SelectedValue = "0";		
				
				
        }
		//Set styles combobox
		List<string> styles_1 = SolarWinds.NPM.Web.Gauge.V1.GaugeHelper.GetAllGaugeStyles(GaugeType.Radial);
		List<string> styles_2 = SolarWinds.NPM.Web.Gauge.V1.GaugeHelper.GetAllGaugeStyles(GaugeType.Radial);
		List<string> styles_3 = SolarWinds.NPM.Web.Gauge.V1.GaugeHelper.GetAllGaugeStyles(GaugeType.Radial);
		stylesList_1.DataSource = styles_1;
		stylesList_2.DataSource = styles_2;
		stylesList_3.DataSource = styles_3;
		stylesList_1.DataBind();
		stylesList_2.DataBind();
		stylesList_3.DataBind();
		string style_1 = Resource.Properties["Style_1"];
		string style_2 = Resource.Properties["Style_2"];
		string style_3 = Resource.Properties["Style_3"];
		if (string.IsNullOrEmpty(style_1))
			style_1 = "Elegant Black";
		if (string.IsNullOrEmpty(style_2))
			style_2 = "Elegant Black";	
		if (string.IsNullOrEmpty(style_3))
			style_3 = "Elegant Black";				
		stylesList_1.SelectedValue = style_1;
		stylesList_2.SelectedValue = style_2;
		stylesList_3.SelectedValue = style_3;
		//Set sample gauges panel

		foreach (string gaugeStyle in styles_1)
		{
			SolarWinds.NPM.Web.Gauge.V1.Gauge gauge = new SolarWinds.NPM.Web.Gauge.V1.Gauge();
			gauge.GaugeStyle = gaugeStyle;
			gauge.IsSample = true;
			GaugeStylesPanel.Controls.Add(gauge);
		}		
	}

	protected void SubmitClick(object sender, EventArgs e)
	{
        this.Page.Validate();
        if (this.Page.IsValid)
        { 
	        Resource.Properties["Scale_1"] = scaleInput_1.Text;
			Resource.Properties["Scale_2"] = scaleInput_2.Text;
			Resource.Properties["Scale_3"] = scaleInput_3.Text;
	        Resource.Properties["Style_1"] = stylesList_1.SelectedValue;
			Resource.Properties["Style_2"] = stylesList_2.SelectedValue;
			Resource.Properties["Style_3"] = stylesList_3.SelectedValue;
    		
	        //Custom 
	        if ((CustomPoller_1.Items.Count+CustomPoller_2.Items.Count+CustomPoller_3.Items.Count) > 0)
	        {
                string pollerName_1 = CustomPoller_1.Items[CustomPoller_1.SelectedIndex].Text;
	            Resource.Properties["CustomPollerID_1"] = CustomPoller_1.SelectedValue;
	            Resource.Properties["CustomPollerName_1"] = pollerName_1;
				string pollerName_2 = CustomPoller_2.Items[CustomPoller_2.SelectedIndex].Text;
	            Resource.Properties["CustomPollerID_2"] = CustomPoller_2.SelectedValue;
	            Resource.Properties["CustomPollerName_2"] = pollerName_2;
				
				string pollerName_3 = CustomPoller_3.Items[CustomPoller_3.SelectedIndex].Text;
	            Resource.Properties["CustomPollerID_3"] = CustomPoller_3.SelectedValue;
	            Resource.Properties["CustomPollerName_3"] = pollerName_3;

                if (string.IsNullOrEmpty(resourceTitleEditor.ResourceTitle))
                {
                    Resource.Title = string.Format("Double Custom Poller Radial Gauge");
                }
                else
                {
                    Resource.Title = resourceTitleEditor.ResourceTitle;
                    Resource.SubTitle = resourceTitleEditor.ResourceSubTitle;
                }

		        SolarWinds.Orion.Web.DAL.ResourcesDAL.Update(Resource);
	        }

			
		
			
	

	        Resource.Properties["Min_1"] = GaugeMinVal_1.Text;
			Resource.Properties["Min_2"] = GaugeMinVal_2.Text;
			Resource.Properties["Min_3"] = GaugeMinVal_3.Text;
	        Resource.Properties["Max_1"] = GaugeMaxVal_1.Text;
			Resource.Properties["Max_2"] = GaugeMaxVal_2.Text;
			Resource.Properties["Max_3"] = GaugeMaxVal_3.Text;
			Resource.Properties["OldEngine_1"] = OldEngine_1.SelectedValue;
			Resource.Properties["OldEngine_2"] = OldEngine_2.SelectedValue;
			Resource.Properties["OldEngine_3"] = OldEngine_3.SelectedValue;
	        Resource.Properties["CustomScales_1"] = AutoScaleGauge_1.SelectedValue;
			Resource.Properties["CustomScales_2"] = AutoScaleGauge_2.SelectedValue;
			Resource.Properties["CustomScales_3"] = AutoScaleGauge_3.SelectedValue;
	        Resource.Properties["Legends_1"] = GaugeTickCount_1.SelectedValue;
			Resource.Properties["Legends_2"] = GaugeTickCount_2.SelectedValue;
			Resource.Properties["Legends_3"] = GaugeTickCount_3.SelectedValue;
	        Resource.Properties["WarningLevel_1"] = WarningLevel_1.Text;
			Resource.Properties["WarningLevel_2"] = WarningLevel_2.Text;
			Resource.Properties["WarningLevel_3"] = WarningLevel_3.Text;
	        Resource.Properties["ErrorLevel_1"] = ErrorLevel_1.Text;
			Resource.Properties["ErrorLevel_2"] = ErrorLevel_2.Text;
			Resource.Properties["ErrorLevel_3"] = ErrorLevel_3.Text;
	        Resource.Properties["ReverseThreshold_1"] = ReverseThreshold_1.SelectedValue;
			Resource.Properties["ReverseThreshold_2"] = ReverseThreshold_2.SelectedValue;
			Resource.Properties["ReverseThreshold_3"] = ReverseThreshold_3.SelectedValue;
	        Resource.Properties["CustomLegends_1"] = CustomLegend_1.Text;
			Resource.Properties["CustomLegends_2"] = CustomLegend_2.Text;
			Resource.Properties["CustomLegends_3"] = CustomLegend_3.Text;
	        Resource.Properties["Title_1"] = Title_1.Text;
			Resource.Properties["Title_2"] = Title_2.Text;	
			Resource.Properties["Title_3"] = Title_3.Text;				
	        Resource.Properties["AutoHide"] = AutoHide.SelectedValue;
            Resource.Properties["SubTitle"] = resourceTitleEditor.ResourceSubTitle;
   		
		    NavigateToPreviousView();
        }            
	}

	protected void BackClick(object sender, EventArgs e)
	{
		NavigateToPreviousView();
	}	

    protected void ValidateDecimalNumber(object sender, ServerValidateEventArgs args)
    {
        decimal argValue=0;
		args.IsValid = decimal.TryParse(args.Value, out argValue);
	}
}
